RCEdit HTML Help

RCEdit HTML Help | RCEdit Logo
Last modified: August 02, 1999
Home page: | http://members.home.net/robstef/rceditinfo.html
Bug reports: | http://members.home.net/robstef/feedback.html
Known issues: | http://members.home.net/robstef/rceditki.html
E-mail Robert Chapman: | robstef@home.com


Introduction

  • License Agreement and Disclaimer
  • About the author, Robert Chapman
  • Why was this editor created?
  • Who should use this editor?
  • Is this the only HTML editing tool that I will ever need?
  • Where is the editor's homepage?
  • What do I do if I find a bug?
  • Program Errors
  • Credits and Acknowledgements


License Agreement and Disclaimer

RCEdit is a freeware application. You may distribute it to anyone provided that the setup archive remains unmodified. Users of this program understand that the designer, Robert Chapman, is not responsible for any damage that this program may directly or indirectly cause to the users machine and or data contained on the user's machine.


About the author, Robert Chapman

I am software developer working with the Microsoft Windows DNA three-tier programming architecture. Prior to becoming a full-time developer I worked for Public Works and Government Services Canada, a Canadian Federal Government department. My work focused on internet publishing and programming for federal government departments.

I can be reached at robstef@home.com or http://members.home.net/robstef/feedback.html.


Why was this editor created?

The editor was created first from a desire to learn the Visual Basic programming language. When I took a job as an Internet Document Specialist for Public Works and Government Services Canada I realized that my editor could help me quite a lot in my day to day duties.

I still use my program in my new job as a full-time programmer. These days I use the program to create ASP pages, static HTML and client side script modules. I add new features to the program as I realize new workplace needs or when users request a cool improvement.


Who should use this editor?

Full-time internet publishers who create HTML documents or any other type of text based internet source document such as Perl scripts or C source files.

The editor places a heavy emphasis on bulk processing. Many of the features found in the editor are programmed to work on an entire directory structure or list of user selected files. Authors who often inherit sites will find this editor helpful in treating entire web sites for link case references and the like.

Authors would frequently markup press releases, speeches and other official correspondences will find the editor's keyboard shortcuts and user defined templates quite useful.

The addition of the Virtual Directories feature now enables hard core programmers to use the program for real-time development against Personal Web Server and IIS web servers.


Is this the only HTML editing tool that I will ever need?

After being is this business for many years I can honestly say NO! To be successful in the internet publishing field authors must continually evaluate new tools to add to their toolkit. This editor could be a valuable addition to any authors toolkit, however, it is not the first and last tool you will ever need. This editor is meant to be a compliment to the author's toolkit.

Many uses have mailed me and asked what tools I use in my daily work. Here is a list of some of them:

  • RCEdit (of course!)
  • Visual Interdev
  • Visual Basic
  • MSDN Help Files (I live in the help files most days)
  • SQL Server 7.0 and associated tools
  • and many more...


Where is the editor's homepage?

The home page for the editor can be found at http://members.home.net/robstef/rceditinfo.html. Bugs can be reported at my web site's feedback page. Please consult the known issues page prior to submitting a bug report.


What do I do if I find a bug?

Please take note of what you were doing at the time you encountered the bug. When an error message is presented to the user it is accompanied by an error number and error description. This information is written to a file in the editor's directory called errors.txt. Please include the contents of this file when submitting a bug report.

Sometimes you may encounter strange behavior that does not register within the program as an error. A detailed account of exactly what you were doing at the time of the behavior would be of great help in reproducing the behavior.

Bugs can be reported at my web site's feedback page. Please consult the known issues page prior to submitting a bug report.


Program Errors

A message will be presented to the user when a program error occurres. All errors are logged to a file in the program directory called errorlog.txt. The error log may be viewed by selecting "View Error Log" from the help menu.

Errors that are not obviously discountable should be reported as a bug. An example of an easily discountable error would be a file that is reported as missing because the user deleted it. The error log records three pieces of information, the date, the error number, and the error description. Example:

Thursday, July 09, 1998 48 File not found: SHBrowse.dll

Bugs can be reported at my web site's feedback page. Please consult the known issues page prior to submitting a bug report.


Revision History

Version 0.9.139

  • Fix: "Invalid property value" error occurred when minimizing the active window(s)

Version 0.9.138

  • Fix: "Unable to write to VDirs.txt" bug no longer occurs.
  • Fix: Tags, Special Characters, Quickfile, and Document Assistant toolbar buttons were not maintaining their proper state, pressed or unpressed. Button state is now correct at all times.

Version 0.9.136

  • Fix: File save error was not properly reported

Version 0.9.129

  • Install: Re-compiled with Visual Basic Service Pack 3, system files shipped should be latest and greatest
  • Addition: Inline preview, documents can now be viewed in source mode and preview mode
  • Addition: Virtual Directory mapping, allows previewing against real web servers
  • Fix: Total re-write of document management classes
  • Install: Removed SubClass.ocx, no longer required
  • Install: Removed MFC42.dll from the install archive, this file was a pain during install and I am not convinced that it is needed by my program
  • Install: Removed DIRWALK.OCX from the install, replaced with RCFileSystem.dll, dirwalk.ocx was a pain during install on Windows 95 machines, the RCFileSystem inprocess server should remove the install related problems

Version 0.9.114

  • Fix: HTML Help now links to proper topics
  • Addition: Quick File utility
  • Fix: Relative pathing now handles any mix of lower and upper case file paths
  • Fix: Program source code optimized in many locations, hopefully users will notice a speed increase
  • Addition: Change the line counter in the status bar to count both characters and lines
  • Fix: Changing the initial directory in the options no longer requires closing and re-opening the program to take effect, it now happens immediately

Version 0.9.109

  • Recompiled and packaged archive with Visual Basic 6.0 Service Pack 2
  • Added missing error handling in certain class modules
  • Fixed BGCOLOR option on Quick Color to use quotes
  • Fixed overflow error when pasting large files into the active window
  • Fixed file not found error when attempting to use calculator option from toolbar while running under NT
  • Fixed relative directory option under NT
  • Added support for network drives in relative pathing option
  • Fixed file permission issues while running under NT
  • Added MFC42.dll to archive, this file is again required

Version 0.9.107

  • Recompiled and packaged archive with Visual Basic 6.0 Service Pack 1
  • Now runs on Windows 95, Windows 98, Windows NT 4.0 Workstation, and Windows NT 4.0 Server
  • Removed link.cur from archive, no longer required
  • Setup now creates an RCEdit program group and places all program icons within the group
  • Removed date time selection
  • Removed MFC42.dll from archive, no longer required
  • Removed DTDLG.ocx from archive, no longer required
  • Cleaned up special character source code, no changes apparent to the user
  • Added more options to the quick color feature, see help file for details
  • Added improved date time insertion using a scrollable calendar and many date and time formats
  • Added BR to main toolbar
  • Added top.js script to scripts directory. Nice for "unframing" your pages if someone else tries to link them into a frameset
  • Updated HTML Help file accordingly

Version 0.9.99

  • Changed program name to RCEdit, see web site What's New page for details
  • Fixed another bug with the tabstrip handler class module
  • Minor changes to the help file

Version 0.9.95

  • Fixed an incredibly stupid bug with the tabstrip handler. Of course this bug just happened to be the worst yet and was in the version that was released to Winfiles.com. This is the way of the universe I guess...

Version 0.9.94

  • added option for default filter
  • changed <INPUT TYPE="TEXTBOX" to <INPUT TYPE="TEXT", was incorrect
  • added .shtml to file selection filters
  • added automatic text selection to all form element windows
  • fixed the prompt for link feature to return focus to the active window once the feature terminates
  • rewrote the tab management module, now a class module, should get rid of error 35601 Element not found
  • added menu option to Options help menu for default filter
  • made required changes to help file


Credits and Acknowledgements

I would like to thank the following people for their invaluable contributions to this learning adventure.

My wife, Stefanie:
For putting up with the long hours I spent in isolation since I first unwrapped VB 4.0 standard edition and began learning VB.

My brother, Graham:
For pointing out when my code was bogus and teaching me some good programming tricks.

The gang from my previous job at Public Works and Government Services Canada:
For testing the program while it was being developed.

Jim Janelle:
For providing the extremely useful, and extremely free, SHBrowse.dll. This handy .dll is used for all of the directory browsing windows in this program.


Program Configuration

Program configuration options can be set from the RCEdit Options Window. To access this window select Options from the View menu.

  • Always use lower case filenames when building filenames
  • Replace \ with / in filename statements
  • Open new untitled file at startup
  • Use relative filenames whenever possible
  • Default Filter
  • Default script language
  • Username
  • Initial directory
  • Prefilling the meta generator field
  • Prefilling the meta author field
  • Start program with Quick File enabled
  • User Strings
  • Browsers
  • Virtual Directories


Always use lower case filenames when building filenames

Activating this option forces a lowercase conversion on any function that creates a link to a filename. Some examples of when this option would have an affect are: image tags, linking to a file on the system, and linking to a name anchor in another file.

Adopting a lowercase filename convention is a good idea for users who publish to UNIX web servers where filename are case sensitive. This option works well with WS_FTP's option to force lowercase filenames on file upload.


Replace \ with / in filename statements

This option simply converts the dos/windows based directory separator "\" to the UNIX compliant "/" directory separator.


Open new untitled file at startup

This option opens a new untitled file at program startup.


Use relative filenames whenever possible

This option is useful for those authors who mirror a web site on their hard drive for development. For example, my site lives at:

http://members.home.net/robstef/

I have a copy of the web site on hard drive in the directory:

c:\HTML Edit\Sites\Latest\

All directories and filenames above the initial start directory are exactly the same on my hard drive and the web server.

If the file I am working on is c:\HTML Edit\Sites\Latest\feedback.html and I want to insert an image tag the SRC attribute being c:\HTML Edit\Sites\Latest\images\wrench.gif then the image tag would appear as:

<IMG SRC="images/wrench.gif">

The relative path option takes the source html file path and the image path from which it returns a relative path that will function on both my local drive and the web server. This method also allows the author to move the site from one server to another painlessly without having to change file references.


Default filter

This option controls which filter will be used when the file selection window is invoked. Only files with matching extensions will be shown in the file selection window. The choices for default filter are:

  • All Files (*.*)
  • CGI Source Files (*.cgi, *.pl, *.pm, *.c, *.h)
  • HTML Files (*.html, *.htm, *.shtml)
  • Text Files (*.txt)
  • Web Related (*.asp, *.js, *.vbs, *.tpl, *.cdf)


Default script language

This option controls how the Script Assistant will function. When the Script Assistant is invoked it will gather references to all the script files matching the user's chosen script language. If the user chooses JavaScript as their default script language then the Script Assistant will search for all files in the application's script directory with the extension .js. If the user chooses VBScript as their default script language then the Script Assistant will search for all files in the application's script directory with the extension .vbs.

The default script language also has one more implication. None of the script files contain the <SCRIPT> tag. This is because the user may wish to enter the script functions found in the script file into an existing <SCRIPT> tag in their active html file.

The Script Assistant's Options tab allows the user to decide whether of not to wrap the script function in a <SCRIPT> tag when the text is inserted into the html file. The default script language impacts which language the <SCRIPT> tag contains. If the user has JavaScript selected as their default script language then the <SCRIPT> tag will read as:

<SCRIPT LANGUAGE="JavaScript">

If the user has VBScript selected as their default script language then the <SCRIPT> tag will read as:

<SCRIPT LANGUAGE="VBScript">

Script Assistant Options Tab

For more detailed information please consult the Script Assistant help file.


Username

The username or organization name that the user wishes to appear in the meta author tag. An example would be:

<META NAME="Author" CONTENT="Robert Chapman">


Initial directory

The default directory that will be shown when the user first activates a browser window or common dialog box. After the user has opened a file that file's directory is stored and used for the next browse dialog. This idea of remembering the last directory used only persists for the duration of the program session. Once the program is closed the last used directory is forgotten.

Double click on the textbox labeled "Initial Directory" to access the directory browser.


Prefilling the meta generator field

This option allows for the prefilling of the Meta generator text field on the Format Document window. It will simply insert RCEdit 32-bit HTML Editor into the text field saving the author the effort of manually entering it.


Prefilling the meta author field

This option allows for the prefilling of the Meta author text field on the Format Document window. It will simply insert the username, as defined by the user under options, into the text field saving the author the effort of manually entering it.


Start program with Quick File enabled

Controls the startup behavior of the Quick File open utility. Changing this option does not affect the current state of the Quick File open utility. The change will take affect the next time the program is run.


User Strings

User strings are blocks of text associated with a unique key name. The unique key name appears in the pull down combination box labeled (User Strings) found on the toolbar. This feature offers the user a quick way of inserting common blocks of text into the active document.

User string definition form User string toolbar pulldown combo box

The Add User String window "String Contents" text input box supports the non-limited shortcut keys.

User String - Add User String


Browsers

Users are permitted to enter up to 15 alternate browsers for previewing the active document. Alternative indicates a browser other than the system's default browser. My system default browser is MS IE 4.01, therefore, I have created entries for Netscape 2.0, Netscape 3.0, Netscape 4.0 and Mosiac 3.0. This will allow we to preview saved documents in any of these browsers by simply right clicking in the active document. The user is required to give each browser a unique name and specify the path to the program's executable file.

User defined browsers Active Document Preview with Alternate Browser


Virtual Directories

In RCEdit a virtual directory is simply a replacement of a partial file path with an URL. Consider the following example. A user is running Personal Web Server that is installed in c:\inetpub\wwwroot\. The user accesses their PWS via http://localhost/ or http://127.0.0.1/. The user is working on their default web page which has been saved to c:\inetpub\wwwroot\default.asp.

Attempting to preview the ASP document without setting up and enabling a Virtual Directory would simply result in the web browser window presenting the user with a Save As dialog box. Creating a virtual directory will allow the user to preview the ASP document in a web server context with all ASP code compiled and sent to the web browser as textual output.

Setting up a virtual directory is simple. Access the Options dialog from the View Menu and click on the Virtual Directories tab. Once the add button is clicked the user will be presented with two dialogs where they can pick the file system directory and the URL for the virtual directory. The image below shows what the final Virtual Directory setup would like.

Virtual Directories Tab in the Options Dialog

Whenever a user toggles the document from source mode to preview mode RCEdit determines the fully qualified URL to the ASP file. c:\inetpub\wwwroot\default.asp is previewed as http://localhost/default.asp. The status bar seen at the bottom of the document window while in preview mode would reflect http://localhost/default.asp as the active URL.

Virtual directories must be enabled for this feature to work. Virtual Directories can be enabled from the Virtual Directories tab in the Options dialog or from the Document Assistant toolbar. Disabling virtual directories does not delete previously created settings; it simply caused RCEdit to ignore the settings.

Document Assistant Toolbar

The top two bottom icons on the above toolbar image are used
to toggle between disabled Virtual Directories and enabled Virtual Directories.

This feature also works with network paths and mapped network directories making it a very useful feature for authors who routinely work on IIS Web Servers available on their network.


Program Features

  • Convert Special Characters
  • Date and Time Insertion
  • Document Modes
  • Extended Find
  • File Case Renamer
  • Find
  • Find and Replace
  • File/URL Case Changer
  • Format Document
  • Image Assistant
  • Link Manager
  • Local URL Viewer
  • Multifile Find and Replace
  • Quick Color
  • Quick Text Format
  • Scratch Pad
  • Script Assistant
  • Shortcut Keys
  • Special Characters
  • Table Wizard
  • Tags
  • Templates


Convert Special Characters

This utility allows the user to convert special characters to their HTML translated values or vice versa. An example would be converting é to &eacute.

Convert Special Characters

This type of conversion is not generally required with today's technology, however, it is considered good form and it does assure universal access to your pages which contain special characters.

Characters converted are:

À
Á
Â
Ã
Ä
Å
Æ
Ç
È
É
Ê
Ë
Ì
Í
Î
Ï
Ð
Ñ
Ò
Ó
Ô 		Õ
Ö
Ø
Ú
Ù
Û
Ü
Ý
Þ
ß
á
à
â
ã
ä
å
æ
ç
è
é
ê 		ë
ì
í
î
ï
ð
ñ
ó
ò
ô
õ
ö
ø
ù
ú
û
ü
ý
þ
ÿ


Date and Time Insertion

This feature allows dates and times to be inserted into the active document. Any date between 01/01/1753 and 12/31/999 may be selected.

Formats offered are:

  • 12/28/98
  • 12/28/1998
  • 98/12/28
  • 1998-12-28
  • 28-Dec-98
  • Monday, December 28, 1998
  • December 28, 1998
  • Monday, 28 December, 1998
  • 28 December, 1998
  • 10:03:50 AM
  • 10:03:56

Date and Time Insertion

Selecting a date from the calendar automatically updates the selections in the listbox. Clicking the Insert button or double clicking an entry in the listbox will cause the entry to be inserted into the active document and the Date and Time insertion window to close.

Clicking on the month name will display two more buttons which allows for scrolling between the current month in previous or upcoming years.

Date and time, year scrolling


Document Modes

Every document that a user opens can be viewed in one of two modes, source or preview. The source mode shows the document as raw text, the preview mode displays the document in an Internet Explorer web browser window.

Users should be aware that only certain types of documents should be viewed in preview mode. It would not make any sense to view a C or Perl source code file in the web browser, however, HTML files are perfect for the preview mode.

Document modes can be switched from the View menu or from the Document Assistant toolbar. Each open document maintains it's own state. Therefore, a user can have several documents open in any combination of modes. Icon states and menu items are updated as each document becomes the active document.

View Menu (Document Modes) Document Assistant Toolbar

The top two top icons on the above toolbar image are used
to toggle between the two available document states, source and preview.

An additional status bar has been added to the preview mode window. This status bar shows the fully qualified path to the file/URL of the document being displayed. This feature is useful when using the Virtual Directories feature.

Users who wish to view ASP files and other server pre-compiled technologies should consult the help document concerning Virtual directories.

Currently there are some issues with the preview mode, please consult the known issues web page for details.


Extended Find

This utility allows the user to search files for a single or multiline block of text. This window hovers above the active document for easy access. The filter can be set to one of many file extension patterns. The find works on a directory basis and does include the option to recursively search subdirectories of the chosen directory. Double click on the textbox labeled "Look in" to access the folder selector.

Extended Find - Criteria Tab

An option to match case allows for precise text matching. Once the files have been gathered and searched the results are displayed in a list that is accessible by clicking the results tab. Note, this tab is not activated until the search is complete. The filename and number of matches are displayed in the results list. File may be opened from the results list by selecting the file or files, right clicking, and selecting "Open selected files" from the menu.

Extended Find - Results Tab


File Case Renamer

The File Case Renamer is a separate program that ships with RCEdit. Its purpose is to rename files on the user's local system to upper or lower case. This utility follows the theme of always working in one case. A practical application would be for the web master to use this utility, in conjunction with other RCEdit features, on a web site the he has inherited in order to guarantee the correct case across all files.

File Case Renamer

This program does not have to be executed from RCEdit. A user can make a shortcut to the program executable that is stored in the RCEdit program directory.


Find

The find window will search the active document for the selected text. This window hovers above the active document for easy access and automatically closes when no documents are open. When the find window loads it retrieves the last five text values that the user searched for from the system registry. The values are accessible by from the pull down combination box. Each new value entered by the user is added to the list. The list may grow beyond five items while the window is loaded, however, once closed only the last 5 values will be saved to the registry.

Users may limit the find search by selecting the Whole Word and Match Case options. The caption of the "Find" button will change to "Find Next" after the first occurrence of the target text is found. A message will be given if no matches can be found.


Find and Replace

Find and Replace will change all occurrences of one block of text to another within the active document. This window hovers above the active document for easy access and automatically closes when no documents are open. When the window is loaded it will prefill the "Enter the text you wish to find" box with the selected text from the active document. This window supports the non-limited shortcut keys.

Find and Replace

Users may choose to replace all occurrences at once without any prompting or to replace one occurrence at a time via a yes or no prompt. The process may be cancelled at any time by selecting the "Cancel" button. Once the search is complete the total number of matches will be calculated and displayed.

User may limit the replacement process by selecting from the Whole Word, Match Case, and Replace within selected range options. When the "Replace within selected range" option is selected the "Enter the text you wish to find" box is cleared. The fastest way to achieve results during a typical selected range find and replace is:
  1. copy from the active document the text which should be found and replaced
  2. select the text range where the replacement should occur
  3. activate the Find and Replace window
  4. select the "Replace within selected range option"
  5. paste the target text into the "Enter the text you wish to find" box

Find and Replace - Replace within selected range option


File/URL Case Changer

This feature allows the user to change the case references of many common HTML tags. This is useful for controlling case reference structure across large sites.

The feature can work on the active document, a user defined list of files, or a directory structure. A file filter must be selected if the user chooses to work on a directory structure. Many file formats and groups of formats are reflected in the filer list. Users should take note that ALL FILES are opened when the (All files) filter is selected. This means that an executable file will be opened and re-written if it is found in the target directory. Users should use this feature at their own risk, please consult the License Agreement and Disclaimer for further details. Testing indicates that this process does not corrupt the test executable files, however, timestamps and file checksums will be affected potentially causing virus protection software to report false infections.

File/URL Case Changer

The Options tab allows the user to specify which HTML tag parameters should be located and changed do the desired case. The desired case is also selected on this tab.

File/URL Case Changer - Options tab

Once the target files have been chosen and the options set the Apply button will be become enabled allowing the process to be launched. The results tab displays an entry for each filename and attribute as it is processed. Icons are displayed indicating success or failure of each selected attributes replacement. A failure indicates that one or more references to the attribute are incorrectly formatted in the target file.

File/URL Case Changer - Results tab


Form Elements

Form elements are accessed via the Form Elements toolbar found under the Toolbars menu. This menu is not visible by default.

Form Elements Toolbar

  • Form method/action
  • Textbox
  • Textarea
  • Checkbox
  • Radio button
  • Select
  • Image (submit)
  • Hidden
  • Password
  • Reset
  • Button (for scripting only)
  • Submit


Form method/action

Creates the form open tag with attributes for the form's method, action and name. The program stores the last five form actions in the system registry for easy access to favorite form actions.

The above example would yield the following text:

<FORM NAME="test_form" METHOD="POST" ACTION="/cgi-bin/test.pl">

</FORM>

The cursor is placed at the beginning of the blank line prior to the end form tag to allow for the insertion of form elements.


Textbox

Creates an input tag of type textbox and allows the attributes of name, value, length and maxlength to be set. The increment/decrement buttons next to length and maxlength will cycle between 0 and 250. The text-input boxes may be edited manually, only numerical values are allowed.

The above example would yield the following text:

<INPUT TYPE="TEXTBOX" NAME="f_name" MAXLENGTH="25" SIZE="25">


Textarea

Creates a textarea with attributes for rows, columns, and name. The increment/decrement buttons next to rows and columns will cycle between 0 and 250. The text-input boxes may be edited manually, only numerical values are allowed.

The above example would yield the following text:

<TEXTAREA NAME="comments" ROWS="5" COLS="40"></TEXTAREA>


Checkbox

Creates a checkbox group with attributes for items, name, and default selection. The example below illustrates how to start entering data. The checkbox group name is only entered once, this name is used in each generated input tag for the group. Enter a textual description for the checkbox item, this is the text that the web site user will see. Assign the item a value, this is the value which is submitted when the user submits the form. Mark the item as the default selection if required. Only one item may be the default selection. Once the default selection is assigned to an item it may not be removed. The item that has the default selection assignment must be deleted to free up the default selection.

Checkbox - Start

Click the "Add to list" button" to create the checkbox item. Repeat the process for each additional checkbox item required for the group.

Checkbox - mid point

Click the "Insert" button to insert the text into the active document.

Checkbox - finish

The above example would yield the following text:

<INPUT NAME="software" TYPE="CHECKBOX" CHECKED VALUE="vbasic">Visual Basic</INPUT>
<INPUT NAME="software" TYPE="CHECKBOX"VALUE="vcplus">Visual C++</INPUT>
<INPUT NAME="software" TYPE="CHECKBOX" VALUE="msaccess">MS Access</INPUT>


Radio button

Creates a radio group with attributes for items, name, and default selection. The example below illustrates how to start entering data. The radio button group name is only entered once, this name is used in each generated input tag for the group. Enter a textual description for the radio button item, this is the text that the web site user will see. Assign the item a value, this is the value that is submitted when the user submits the form. Mark the item as the default selection if required. Only one item may be the default selection. Once the default selection is assigned to an item it may not be removed. The item that has the default selection assignment must be deleted to free up the default selection.

Radio button - start

Click the "Add to list" button" to create the radio button item. Repeat the process for each radio button item required for the group.

Radio button - mid point

Click the "Insert" button to insert the text into the active document.

Radio button - finish

The above example would yield the following text:

<INPUT NAME="software" TYPE="RADIO" CHECKED VALUE="vbasic">Visua Basic</INPUT>
<INPUT NAME="software" TYPE="RADIO" VALUE="vcplus">Visual C++</INPUT>
<INPUT NAME="software" TYPE="RADIO" VALUE="msaccess">MS Access</INPUT>


Select

Creates a select group with attributes for items, name, and default selection. The example below illustrates how to start entering data. The select group name is only entered once, this name is used in each generated input tag for the group. Enter a textual description for the select item, this is the text that the web site user will see. Assign the item a value, this is the value which is submitted when the user submits the form. Mark the item as the default selection if required. Only one item may be the default selection. Once the default selection is assigned to an item it may not be removed. The item that has the default selection assignment must be deleted to free up the default selection.

Select - start

Click the "Add to list" button" to create the select item. Repeat the process for each select item required for the group.

Select - mid point

Click the "Insert" button to insert the text into the active document.

Select - finish

The above example would yield the following text:

<SELECT NAME="software">
<OPTION SELECTED VALUE="vbasic">Visual Basic</OPTION>
<OPTION VALUE="vcplus">Visual C++</OPTION>
<OPTION VALUE="msaccess">MS Access</OPTION>
</SELECT>


Image (submit)

Create an input tag of type image. This type of input tag always causes the form to be submitted. The value text input box only appears when the window is activated from the form element toolbar. Different VALUE attributes should be set if multiple image input tags are required for form submission. Don't forget to use the same NAME attribute for multiple submit images. The CGI or process that receives the form data can then test against the different values.

An example of an image input tag would be:

<INPUT TYPE="image" SRC="fancy_button.gif" NAME="submit" ALT="Submit image" WIDTH="305" HEIGHT="312" HSPACE="2" VSPACE="2" BORDER="2" ALIGN="LEFT" VALUE="submit_1">


Hidden

Create an input tag of type hidden. Typically used to pass name/value pairs to the CGI or process that receives submitted form data.

The example above would yield the following text:

<INPUT TYPE="HIDDEN" NAME="passed_value" VALUE="19987">


Password

Creates an input tag of type password and allows the attributes of name, value, length and maxlength to be set. The increment/decrement buttons next to length and maxlength will cycle between 0 and 250. The text-input boxes may be edited manually, only numerical values are allowed.

The above example would yield the following text:

<INPUT TYPE="PASSWORD" NAME="password" MAXLENGTH="25" SIZE="25">


Reset

Create an input tag of type reset. The only attribute that may be set is VALUE.

The example above would yield the following text:

<INPUT TYPE="RESET" VALUE="Clear Form">


Button

Create an input tag of type button with attributes for NAME and VALUE. This type of input tag is only used for client-side scripting.

The example above would yield the following text:

<INPUT TYPE="BUTTON" NAME="test" VALUE="Test OnClick Event">


Submit

Create an input tag of type submit with attributes for NAME and VALUE. This type of input tag is used to submit the form data.

The example above would yield the following text:

<INPUT TYPE="SUBMIT" NAME="submit" VALUE="Send comments">


Format Document

This is one of the few two features in the editor. Most features generate HTML and insert the block of text into the active document. This feature allows the user to set document properties that can be read later and modified again. The appropriate HTML is re-generated and textual replacements are made as required.

Attributes exposed for modification are title, document colors, basefont, onload functions, meta data, and document background graphic.

Document colors are only read if they were originally entered by the user in HEX format, real words such as "white" will not be read in for editing. Double clicking on any of the color fields will present the user with a color selection browser. Once a color is selected its HEX value is calculated and entered into the textbox. The background color of the textbox is also changed as to allow the user a simple graphical means of viewing the document's color scheme.

Double clicking on the background graphic will present the user with a file selection browser. This field is read-only, all selections must come from the file selection browser. Relative pathing will be applied to the retrieved filename if the user has this option enabled. The fully qualified filepath will be used if the relative pathing option is not enabled or if the active document has not been saved.

The Meta Data tab allows the user to easily enter relevant meta data. The author field and the generator field may be prefilled if the user has these options enabled.

A redirect may be set by including an URL and the desired time delay.

The user may also specify that the client browser should never cache the document. This feature inserts a pragma directive into the header of the document via a meta tag. Please note that this feature is not understood by all browsers and has no impact on the client's history list. Universally acceptable cache protection should be researched by the user if they are mission critical.

Format Document - Meta Data tab


Image Assistant

The Image Assistant allows the user to select, view and set all attributes of an image. Notice in the graphic below that relative directory pathing will be used if the user has activated this option.

The filename field is read-only, filenames must be retrieved by use of the file browser.

Relative pathing will be applied to the retrieved filename if the user has this option enabled. The fully qualified filepath will be used if the relative pathing option is not enabled or if the active document has not been saved.

VSpace and HSpace options will not included in the image tag if their value is 0, however, bordersize will be included even if it's value is 0. The name field is used for scripting purposes only, CGI or client side, and will not be included in the image tag if left blank.

Both height and width are filled in automatically after the user selects an image. The maximum allowable setting for pixel width and pixel height is 2500. Percent ranges from 0 - 100.


Link Manager

The Link Manager stores user defined links in the windows registry. This is slated to change in the next few months, the registry is clearly the wrong place to store this type of information. This window hovers above the active document for easy access.

User may create, edit, and activate links from within the Link Manager. Links may be inserted into the active document at the current cursor location by double clicking on the entry or by selecting the entry and clicking the "Insert" button.

Link Manager - Links tab

Different icons are used for each different type of link. The link label is a textual description of the link and the HTML link text is the text that will be inserted into the active document. The image above shows a relative link.

Click on the "Add a Link" tab to create a new link. The example image below shows a link with a textual description of RCEdit Home Page that links to a link of type http:// to the address members.home.net/robstef/rceditinfo.html. The link text will be RCEdit Home Page. The link example will update as the link is being created or modified. The link example is a clickable hyperlink that can be used for link testing and anchor tag verification. Click the "Add Link" button to add the newly created link to the Link Manager list.

Link Manager - Add a Link tab

Allowable link types are: ftp://, gopher://, http://, mailto:, news:, newsrc:, nntp://, Relative, telnet://, and wais://.

Links may be edited, deleted, or launched from the right click menu. Selecting "Launch browser with this link" will cause the link to be executed to the system's default browser. Editing a link will cause it's values to be displayed a window exactly the same as the add link window for the user to edit. Click the "Save changes" button to save the edited link.

Link Manager - right click menu

Link Manager - Edit Link tab


Link to file on system

Allows quick linking to other files on the user's system. A file browser is presented for file selection after which the link is created.

Link to file on system

Selected text in the active document will be wrapped in the created link or the link will be inserted at the cursor point if no text is selected. The link format is different depending on whether or not the relative pathing option is enabled:

The link will be fully qualified if relative pathing is not enabled or if the active document is not saved.


Link to name anchor

This feature gathers all name anchors from the active document and displays them in a list. The search patterns for name anchors are:

<A NAME="Section 1">Section 1</A> or <A NAME=whatever>Section 1</A>

Link to name anchor

The link is created when the user double clicks on the desired selection or clicks the "Make Link" button. Selected text in the active document will be wrapped in the created link or the link will be inserted at the cursor point if no text is selected. The link format is:

<A HREF="#Section 1"></A>


Link to name anchor in another file

This feature is basically the same as Link to name anchor except that this option allows the user to specify which file to search for name anchors.

Link to name anchor in another file

The link is created when the user double clicks on the desired selection or clicks the "Make Link" button. Selected text in the active document will be wrapped in the created link or the link will be inserted at the cursor point if no text is selected. The link format is different depending on whether or not the relative pathing option is enabled:

Link to name anchor in another file - window

The link would look like the example below if relative pathing is enabled and the active document is saved.

<A HREF="../vb projects/editor/temp/test.html#demo_anchor">Section 5</A>

The link will be fully qualified if relative pathing is not enabled or if the active document is not saved.

<A HREF="c:\vb projects\editor\temp\test.html#demo_anchor">Section 5</A>

A message will be issued if the program does not find any links in the selected file. The user will also be presented with chance to select another file.


Local URL Viewer

The Local URL Viewer is a separate program that ships with RCEdit. Its purpose is to display HTML pages in the default browser in the order specified by the user. This is useful for displaying a list of files that are not linked together in a specific way. An example would be the need to print 100 files that have no linked index. Selecting each file from within the browser's file open dialogs would take a great deal of time.

The Local URL Viewer program is set to always stay on top of all other windows. This allows easy access to the basic navigation controls that facilitate movement between the selected files.

Local URL Viewer

User should note that the files are currently stored in a list in the reverse order that they are selected. User should select the last file first. Multiple selections are allowed with the file browser dialog. The file list is reset each time a selection or selections are made from the file browser.

This program does not have to be executed from RCEdit. A user can make a shortcut to the program executable that is stored in the RCEdit program directory.


Multifile Find and Replace

The Multifile Find and Replace is a powerful text replacement tool with many features. The process is started by entering one or more textual find and replace "pairs" into the find and replace value summary. The value summary has limited editing features once values have been added. The summary pairs can be removed, however, their textual values can not be edited once the values have been entered. If the user makes a mistake the pair will have to be deleted and re-entered into the list.

Find and Replace

The target files tab allows the user to create a list of files that will be subject to the find and replace. Items in the list can be deleted after they have been entered.

Find and Replace - Target Files Tab

Once find and replace pairs have been entered and the target files have been chosen, the Apply button will become enabled and the process may be launched.

The Options tab allows the user to enable case matching, the default is case insensitive. Once enabled, this option applies to all the items on the source->target list. It is not possible to apply the case option to individual items on the list.

The user may also elect to prefill the find and replace values with the HTML special characters, finding and replacing real characters with HTML values or vice versa. This feature is useful for converting special characters across a large amount of files in one process. After clicking the "Add Now" button the user can return to the Find and Replace Values tab and notice that all of the appropriate pairs have been added to the summary.

Find and Replace - Options Tab

The progress bar on the Find and Replace Value tab indicates the status of the find and replace. The user may cancel the process at any time by clicking on the Cancel button. No reporting is done upon process completion or termination.


Prompt for link

Allows for insertion of any link which the user wants to be wrapped in <A HREF="user_supplied_link"></A>. This is very useful for pasting links that have been copied from a web browser.

Prompt for link

Selected text in the active document will be wrapped in the created link or the link will be inserted at the cursor point if no text is selected.


Quick Color

Quick color can be accessed from the Format Text menu of from the main toolbar.

Quick color accessed from the Format Text menu

Quick color accessed from the toolbar

Quick color offers access to four common types of HTML coloring:

Simple Color Value: | 0000FF
Font tag with color attribute: | <FONT COLOR="#FF8000"></FONT>
Color attribute only: | COLOR=#408080
Background color: | BGCOLOR=#FF8040

Notice how the four options listed above correspond to the above picture of the quick color feature being activated from the menu bar, four choices shown as four subordinate menu options. Also note that the above picture of the quick color feature being activated from the toolbar only shows the last three options as listed above. This is because the four quick color options are broken down into two separate toolbar functions. Clicking on the color palette button will invoke the simple color value, clicking on arrow next to the color palette button will drop down a menu with the other three quick color options.

These four options allow flexibility for coloring text, adding a color attribute to a tag which supports it, or changing the color value of an existing tag with the color attribute defined.


Quick File

Quick File is used to quickly open one or more files without having to go to the program menus. Quick File supports multifile open using both the shift and control keys for selection control. Quick File consists of four unique controls:

1. Drive list:
Displays all physical and mapped drives currently available on the system. Changing this list will cause the directory list below to update which in turn causes the file list to update. 		QuickFile
2. Directory list:
Displays all directories available on the selected drive. Clicking on a directory name will expand or contract the directory list depending on whether or not the selected directory contains any subdirectories. Changing this list will cause the file list to update.
3. File type list:
Lists the available file types that the file list will use as a filter. Users may enter their own file type by typing directly into the file type textbox. Changing the file type selection causes the file list to update. The last used file type is stored in the registry and used the next time the program is run.
4. File list:
Displays all files found in the selected directory matching the selected file type. Users may select one or more files to open. Pressing the enter key will open any selected files. User may also open files by right clicking the mouse and selecting Open selected file(s) when one or more files are selected.

Each of the four controls may be resized and repositioned. Simply click on the grey raised bar above the desired control to enable sizing and repositioning. Currently the position of resized or moved controls is not saved, therefore, the controls will be back to their original position the next time the program starts.

Users are not forced to use Quick File. An option exists in the program options to enable or disable Quick File at program startup.

Quick File opens at the initial directory as defined in the program options. Quick File also updates the last used directory, see initial directory for more details.

Quick File may be enabled and disabled at any time by using the toolbar icon or the View menu.

Quick File Toolbar Icon


Quick Text Format

This feature allows the user to quickly gain access to the most common text formatting options. When this window is invoked it will first look to see if the user has any text selected in the active document. Selected text is imported for action and displayed in the "Enter the Application in the box below" text input box.

The "Enter the Application in the box below" text input box supports the non-limited shortcut keys.

Once formatting has been applied the selected text in the active document will be replaced by the newly formatted text. If no text was selected prior to invoking this feature and user entered text directly into the "Enter the Application in the box below" textbox, insertion will occur in the active document at the point where the cursor resides.

Quick Text Format

User will notice from the image above that font face attributes are listed in a cumulative list as each new face is selected. User may edit the font face textbox manually as required.

Only the relevant selected features will be built into the newly created text block.


Scratch Pad

The Scratch Pad acts as a temporary container for blocks of text. The window hovers above the active document for easy access.

Text can be sent directly to the Scratch Pad from the active document by using the right click menu open "Send to Scratch Pad" as illustrated below.

Scratch Pad - Send to Scratch Pad

The Scratch Pad window may be edited by using the right click menu or the "Edit" button. This window supports the non-limited shortcut keys. The user will be prompted to save the contents of this window if text has been added or changed. The save function is available from the right click menu and the 'Edit" button.

Scratch Pad - Edit menu

The program automatically adds two carriage returns to the Scratch Pad window after each use of the "Send to Scratch Pad" function. This is done to help the user distinguish between the separate blocks of text residing in the window.


Script Assistant

When the Script Assistant is invoked it will gather references to all the script files matching the user's chosen default script language. If the user chooses JavaScript as their default script language then the Script Assistant will search for all files in the application's script directory with the extension .js. If the user chooses VBScript as their default script language then the Script Assistant will search for all files in the application's script directory with the extension .vbs.

User can add new script files to the script directory by following the above-mentioned naming convention.

The default script language also has one more implication. None of the script files contain the <SCRIPT> tag. This is because the user may wish to enter the script functions found in the script file into an existing <SCRIPT> tag in their active html file.

The Script Assistant's Options tab allows the user to decide whether of not to wrap the script function in a <SCRIPT> tag when the text is inserted into the html file. The default script language impacts which language the <SCRIPT> tag contains. If the user has JavaScript selected as their default script language then the <SCRIPT> tag will read as:

<SCRIPT LANGUAGE="JavaScript">

If the user has VBScript selected as their default script language then the <SCRIPT> tag will read as:

<SCRIPT LANGUAGE="VBScript">

Script Assistant Options Tab

As the above image illustrates, the default options such as the script directory and desired script language can be temporarily changed during each invocation of the Script Assistant.

Users can gather scripts from a different folder by double clicking on the folder textbox and invoking the directory browser. The script type, or filter, can also be changed by using the pull down combination box labeled filter. Once all of the relevant selections have been made the user must click the "Gather scripts now" button to re-gather the scripts. The newly gathered scripts will be displayed on the Scripts tab or an error message will be presented if no scripts are found.

Clicking the "Insert" button with no script selected will insert a blank script tag only if the user has not modified the default setting for the Script Insertion Method found on the Options tab. If the default setting for the Script Insertion Method has been modified to indicate that no script tag should be used and no script is selected, clicking the "Insert" button will do nothing. The insert button is not enabled when the Options tab is selected.

The Script Preview is an editable textbox supporting non-limited shortcut keys. Editing this textbox will not update the script file, changes are only reflected for the current script insertion.


Shortcut Keys

Many keyboard shortcuts have been added to speed up the editing process. Below is a table of all available key combinations. When applicable, the shortcut action will wrap the users selected text in the desired tag extending the range of the selected text. This allows for the quick us multiple formatting shortcut key combinations without the user having to reselect the desired text.

Support for certain short cut keys is limited because: the keys access program menus, the keys access file-system commands, or the keys access other program features which are specific to the document editing window only. Most multiline textboxes in the program support all non-limited shortcut keys. For example, the add User String input form supports non-limited shortcut keys.

Limited shortcuts are marked by an * and are available from the document window only.

* ALT: | F = file menu E = edit menu I = insert menu L = link menu T = toolbars M = format text B = toolbars V = view W = window H = help
CTRL: | * N = new * O = open B = bold <B></B> I = italics <I></I> U = underline <U></U> * F = find * R = find & replace * S = save X = cut C = copy V = paste Z = undo
CTRL+SHIFT: | Q = quotes " I = list item <LI></LI> * A = save as P = paragraph <P></P> K = blockquote <BLOCKQUOTE></BLOCKQUOTE> * L = link to file on system N = create name anchor C = center <CENTER></CENTER> B = <BR> A = prompt for fully qualified link * S = save as * W = close active window * D = preview active window to default system browser 1 - 6 = headers example: 1 = <H1></H1> and so on


Special Characters

Special Character insertion allows the user to insert the HTML value of any special character into the active document. After each selection of a special character input focus is returned to the active document. This window hovers above the active document for easy access and automatically closes when no documents are open.


Table Wizard

The Table Wizard provides an easy to use interface for creating tables. The wizard begins by asking for the number of rows and columns required for the table.

The next wizard screen allows the user to set the table properties. Maximum values for table width are 100 percent or 2000 pixels. Double clicking on the background color textbox will allow access to the color palette browser. The selected value will then be converted to the proper HEX value and the textbox's background color will change to the selected color. The maximum value for cell spacing, cell padding and border size is 500.

Table Wizard - Table Properties

The next wizard screen allows each table cell's properties to be set. Clicking on a cell will make it the active cell and its properties will be displayed. Take note of the active cell address displayed in blue on the top right of the wizard screen. An address such as C1:R1 translates to column 1 row 1.

The cell text input box supports all of the non-limited shortcut keys for quick formatting. Other support features are also available via a right mouse click menu to assist in quick formatting. These features operate in exactly the same manner as they do in the document window except that none of the windows hover. The window must be closed before the user may type in the table cell text property box again.

Table Wizard - Cell Properties

Table Wizard - Right click menu

The cell background color is accessed in the same manner as the table background color described above. Valid cell alignment values for ALIGN are left, center and right. Valid cell alignment values for VALIGN are top, middle and bottom.

Once all data has been entered and "Finish" is clicked the table is built and inserted into the active document at the current cursor location.

Users may use the back button at any time to change values. It should be noted that using the back button to change the number of rows and columns will cause all table cell data to be lost, however, table properties will be preserved. A warning is issued to confirm the users desire to make the change.


Tags

Tag insertion wraps the selected text from the active document in the selected tag. Only the tag itself is inserted into the active document if no selected text exists. This window hovers above the active document for easy access and automatically closes when no documents are open.

The list displays start syntax, end syntax, and the description of each tag.

User may edit the tags control file found, named tags.txt, in the program directory if custom tags are required. The format is as follows:

  1. only one tag per line
  2. start syntax, end syntax, and description must be separated by commas
    example: <A HREF=>,</A>,Anchor


Templates

Templates allow users to start a new file based on a saved template. This can be a great time saver for any author who finds himself or herself creating many documents of the same structure on a regular basis. This window hovers above the active document for easy access and automatically closes when no documents are open.

Only the default template is shipped with RCEdit. Template are created by following three simple steps:

  1. create the required HTML in the active document in RCEdit
  2. select "Create Template from current file" found under the tools menu
  3. give the template a name

Templates are stored in the program subdirectory named Templates. A template is simply a regular HTML file that has been renamed to user_provided_name.tpl and stored in the proper directory. For this reason is it important to adhere to normal filename rules when following step three listed above. There is no need to add the .tpl extension when assigning the new template a name, the program will do this automatically.

Templates can be edited by selecting the desired template and clicking the "Edit" button on the Templates window.

Templates can be deleted by selecting the desired template and clicking the "Delete" button on the Templates window. A yes or no confirmation will appear offering the user a chance to cancel the deletion. The Default Template can not be deleted.


Toolbars

There are four toolbars that may be used with the program.

  1. Main
  2. Helpers
  3. Form Elements
  4. Drop down combo boxes
  5. Document Assistant

Main:

Toolbars - Main

Functions (listed from left to right, top row then bottom row):
New File, Open File, Save File, Save File As, Print (not implemented), Find, Find and Replace, Copy, Cut, Past, Undo, Delete, Link Manager, Image Assistant, Script Assistant, Table Wizard, Tags, Special Characters, Format Document, Quick Text Format, Center, Right, Bold, Italic, Underline, Line Break (<BR>), Paragraph, Quick Color, About, Exit

Helpers:

Toolbars - Helpers

Functions (listed from left to right):
Scratch Pad, Notepad, Calculator, Windows Explorer, Local URL Viewer, File Case Renamer, Quick File, Document Assistant Toolbar

Form Elements:

Functions (listed from left to right):
Form method/action, Textbox, Textarea, Checkbox, Radio button, Select, Image (submit), Hidden, Password, Reset, Button (for scripting only), Submit

Drop down combo boxes:

Toolbars - dopr down combos

Functions (listed from left to right):
Headings, Font Name, Font Size, User Strings

  • Headings: Wraps selected text in selected heading tag, or if no selected text exists inserts heading tag at cursor insertion point
  • Font Name: Wraps selected text in selected font name tag, or if no selected text exists inserts font name tag at cursor insertion point
  • Font Size: Wraps selected text in selected font size tag, or if no selected text exists inserts font size tag at cursor insertion point
  • User Strings: Replaces selected text with selected user string, or if no selected text exists inserts user string at cursor insertion point

Document Assistant:

Document Assistant Toolbar

The top two buttons toggle the active document between source mode and preview mode. The bottom two buttons toggle the Virtual Directories setting between disabled and enabled.

This toolbar can be aligned and closed at any time by right clicking over the toolbar and accessing the toolbar's configuration menu. This toolbar can also be enabled and disabled from the Helpers toolbar and the View Menu. Using the previously mentioned enable and disable options will only effect the current session of RCEdit. If users want to persist their desire to enable or disable this toolbar they can do so from the Options dialog by clicking the "Start program with Document Assistant Enabled" option.

Document Assistant Configuration Menu


Type Specific Links

Typed links allow for quick insertion of known link types. Activating the http type link would mandate that the user entered www.somesite.com into the text-input box. All typed links simply insert the given text into the proper anchor tag. An http link would wrap the given text in <A HREF="http:// and a mailto link would wrap the given in <A HREF="mailto:.

Selected text in the active document will be wrapped in the created link or the link will be inserted at the cursor point if no text is selected.